import java.io.*;
import java.util.Vector;

public class Reactor
{
   private static int MaximumNumberOfDependents = 10;

   private String myName;
   private Vector myDependents;
   private int    numberOfDependents;

   public Reactor( String reactorName )
   {
      myName             = reactorName;
      myDependents       = new Vector( MaximumNumberOfDependents );
      numberOfDependents = 0;
   }

   public String name ()
   {
      return myName;
   }

   public void addDependent( Reactor watcher )
   {
      if (numberOfDependents < MaximumNumberOfDependents)
      {
         myDependents.addElement( watcher );
         numberOfDependents++;
      }
      else
         System.out.println( "I already have too many dependents!" );
   }

   public void change()
   {
      System.out.println( myName + " is changing." );
      for (int i = 0; i < numberOfDependents; i++)
      {
          Reactor aDependent = (Reactor) myDependents.elementAt( i );
          aDependent.update( this );
      }
   }

   public void update ( Reactor sender )
   {
      System.out.println( "Uh-oh...  "  + myName + " has to change because " +
                          sender.name() + " has changed." );
      change();
   }
}
